import { CancellationDetailsBase, PropertyCollection, ResultReason } from "./Exports";
export interface EnrollmentResultDetails {
    profileId: string;
    enrollmentsCount: number;
    enrollmentsLengthInSec: number;
    enrollmentsSpeechLengthInSec: number;
    remainingEnrollmentsCount: number;
    remainingEnrollmentsSpeechLengthInSec: number;
    audioLengthInSec: number;
    audioSpeechLengthInSec: number;
    enrollmentStatus: string;
}
/**
 * Output format
 * @class VoiceProfileEnrollmentResult
 */
export declare class VoiceProfileEnrollmentResult {
    private privReason;
    private privDetails;
    private privProperties;
    private privErrorDetails;
    constructor(reason: ResultReason, json: string, statusText: string);
    static FromIdentificationProfileList(json: {
        value: any[];
    }): VoiceProfileEnrollmentResult[];
    static FromVerificationProfileList(json: {
        value: any[];
    }): VoiceProfileEnrollmentResult[];
    get reason(): ResultReason;
    get enrollmentsCount(): number;
    get enrollmentsLengthInSec(): number;
    get properties(): PropertyCollection;
    get enrollmentResultDetails(): EnrollmentResultDetails;
    get errorDetails(): string;
    private static getIdentificationDetails;
    private static getVerificationDetails;
}
/**
 * @class VoiceProfileEnrollmentCancellationDetails
 */
export declare class VoiceProfileEnrollmentCancellationDetails extends CancellationDetailsBase {
    private constructor();
    /**
     * Creates an instance of VoiceProfileEnrollmentCancellationDetails object for the canceled VoiceProfileEnrollmentResult.
     * @member VoiceProfileEnrollmentCancellationDetails.fromResult
     * @function
     * @public
     * @param {VoiceProfileEnrollmentResult} result - The result that was canceled.
     * @returns {VoiceProfileEnrollmentCancellationDetails} The cancellation details object being created.
     */
    static fromResult(result: VoiceProfileEnrollmentResult): VoiceProfileEnrollmentCancellationDetails;
}
