// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT license.
import { Contracts } from "./Contracts";
import { VoiceProfileResult } from "./Exports";
/**
 * Output format
 * @class VoiceProfilePhraseResult
 */
export class VoiceProfilePhraseResult extends VoiceProfileResult {
    constructor(reason, statusText, json) {
        super(reason, statusText);
        this.privPhrases = [];
        Contracts.throwIfNullOrUndefined(json, "phrase result JSON");
        if (!!json.value && !!json.value[0]) {
            for (const item of json.value) {
                this.privPhrases.push(item.passPhrase || item.activationPhrase);
            }
        }
    }
    get phrases() {
        return this.privPhrases;
    }
}

//# sourceMappingURL=VoiceProfilePhraseResult.js.map
